var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");

////////////////////////////////////////////////////////////////////////////////////////////////
//
//  CCleaner Functions
//
////////////////////////////////////////////////////////////////////////////////////////////////

function ShowCCleaner()
{
    remove();
    document.getElementById("gRecycleBin").style.visibility = "hidden";
    document.getElementById("gITraces").style.visibility = "hidden";
    document.getElementById("gCCleaner").style.visibility = "visible";

    document.getElementById("gBackground").addImageObject("images/ccleaner.png",9,9);
    document.getElementById("RunMe").innerHTML = LRunMe;
    document.getElementById("TraceInfo").innerHTML = "<img id=\"oTraces\" src=\"images/history.png\">";
    document.getElementById("BinInfo").innerHTML = "<img id=\"oBin\" src=\"images/070.png\">";

    //setup alt for buttons
    document.getElementById("oTraces").setAttribute("alt",LHistAlt);
    document.getElementById("oBin").setAttribute("alt",LBinAlt);
}

function RunCCleaner()
{
    var Prog = oShell.RegRead ("HKEY_CLASSES_ROOT\\cclaunch\\shell\\open\\command\\");
    oExec = oShell.Exec(Prog+"/AUTO");
	
}
			
function OpenCCleaner()
{
    var Prog = oShell.regread("HKEY_CLASSES_ROOT\\cclaunch\\shell\\open\\command\\");
    oExec = oShell.Exec(Prog);
}

////////////////////////////////////////////////////////////////////////////////////////////////
//
//  RecycleBin Functions
//
////////////////////////////////////////////////////////////////////////////////////////////////
function ShowBinInfo ()
{
    //function populates bin information		
    var bsize = System.Shell.RecycleBin.sizeUsed;
    var suffix = '';
	
    //Cleanup Gadget Area			
    remove();
    document.getElementById("gCCleaner").style.visibility="hidden";
    document.getElementById("gRecycleBin").style.visibility = "visible";
    
    document.getElementById("BinTitle").innerHTML = "<a href=\"javascript:OpenBin()\" target=\"blank\">"+ LBin + "</a>";

    if ((System.Shell.RecycleBin.fileCount==0)&&(System.Shell.RecycleBin.folderCount==0))
    {
	document.getElementById("BinSize").innerHTML = LEmpty;
	document.getElementById("FileCount").innerHTML = "0 " + LItems;
    }
    else
    {					
	suffix = GetSuffix(bsize);
	bsize = ConvertSizeOf(bsize);
					
	document.getElementById("BinSize").innerHTML = bsize + " " + suffix;
	document.getElementById("FileCount").innerHTML = ((System.Shell.RecycleBin.fileCount + System.Shell.RecycleBin.folderCount) == 1) ? "1 " + LItem : (System.Shell.RecycleBin.fileCount + System.Shell.RecycleBin.folderCount) + " " + LItems;
    }

    // Get Appropriate RecycleBin Image	
    var ibin = '000';
    
    if ((bsize < 512) && (bsize > 0) && (suffix != "GB"))
    {
	ibin = "030";
    }   
    else if ((bsize > 512) && (suffix != "KB" && suffix != "GB"))
    {
	ibin = "070";
    }
    else if ((bsize > 1) && (suffix == "GB"))
    {
	ibin = "100";
    }

    document.getElementById("gBackground").addImageObject("images/"+ibin+".png",9,9);
}

function MoveToBin()
{
    var item = null;
    var index = 0;

    item = System.Shell.itemFromFileDrop(event.dataTransfer, index);
    while (item != null)
    { 
	if (item)
        {
	    System.Shell.RecycleBin.deleteItem(item.path);
        }
	    
        index++;
	item = System.Shell.itemFromFileDrop(event.dataTransfer, index);
    }
			
    ShowBinInfo();
}

function OpenBin()
{
    ShowBinInfo();
    System.Shell.execute('::{645FF040-5081-101B-9F08-00AA002F954E}'); //Explore the RecycleBin
}

////////////////////////////////////////////////////////////////////////////////////////////////
//
//  INet Trace Functions
//
////////////////////////////////////////////////////////////////////////////////////////////////

function ShowTraceInfo()
{
    var tmpfolder, hstfolder;
    var tmpsize, hstsize, totsize;
  							
    remove();
    document.getElementById("gCCleaner").style.visibility="hidden";
    document.getElementById("gRecycleBin").style.visibility="hidden";
    document.getElementById("gITraces").style.visibility="visible";
    
    document.getElementById("gBackground").addImageObject("images/history.png", 6, 8);
    document.getElementById("TraceTitle").innerHTML = LHistTitle;
 					
    tmpfolder = oShell.ExpandEnvironmentStrings("%userprofile%\\appdata\\local\\microsoft\\windows\\temporary internet files\\");
    hstfolder = oShell.ExpandEnvironmentStrings("%userprofile%\\appdata\\local\\microsoft\\windows\\history\\");
                
    tmpsize = GetFolderSize(tmpfolder);
    hstsize = GetFolderSize(hstfolder);
                			
    totsize = ConvertSizeOf(tmpsize + hstsize) + " " + GetSuffix(tmpsize + hstsize);	
			
	document.getElementById("TraceTmp-n-Hist").innerHTML = totsize;
	document.getElementById("TraceURLs").innerHTML = GetUrlCount() + " " + LTypedURLs;    
}


////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Util Functions
//
////////////////////////////////////////////////////////////////////////////////////////////////

function ConvertSizeOf (insize)
{
    var isize;
    			
    if (insize < 1024)
    {
	isize = insize;		
    }
    else if ((insize >= 1024) && (insize < (1024*1024)))
    {
	isize = insize / 1024;
    }
    else if ((insize >= 1024*1024) && (insize < (1024*1024*1024)))
    {
	isize = insize / 1024 / 1024;
    }
    else if ((insize >= 1024*1024*1024))
    {
	isize = insize / 1024 / 1024 / 1024;
    }
				
    isize = isize + "0"; // to cast integer to string
    isize = isize.substring(0, (isize.length - 1));
					
    var CommaSep = isize.indexOf(".");
    if (CommaSep != -1)
    {
	isize = isize.substring(0, CommaSep + 3);
    }
	
    var newsize = isize.replace(/\./g, LDecimalSep);
				
    return newsize;
}

function GetSuffix (insize)
{
    var suffix;
				
    if (insize < 1024)
    {
	suffix = "B";		
    }
    else if ((insize >= 1024) && (insize < (1024*1024)))
    {
	suffix = "KB";
    }
    else if ((insize >= 1024*1024) && (insize < (1024*1024*1024)))
    {
	suffix = "MB";
    }
    else if ((insize >= 1024*1024*1024))
    {
	suffix = "GB";
    }
	
    return suffix;
}

function GetFolderSize (dir){ return oFSO.GetFolder(dir).Size; }

function GetUrlCount()
{
    ReadDone = false;
    cnt = 0; //count elements in reg key;
    itr = 1; //iterator for traversing typed url
				
    while(ReadDone == false){
        try
	{
	    oShell.RegRead("HKEY_CURRENT_USER\\Software\\Microsoft\\Internet Explorer\\TypedURLs\\url" + itr);
	    itr ++;
	    cnt ++;
	}
	catch(error)
	{
	    ReadDone = true;
	}
    }
    		
    return cnt;
}

function cancel (){ event.returnValue = false; }
function remove (){ document.getElementById("gBackground").removeObjects();}

var gradualFader={}

gradualFader.baseopacity=0.6 //set base opacity when mouse isn't over element (decimal below 1)
gradualFader.increment=0.1 //amount of opacity to increase after each iteration (suggestion: 0.1 or 0.2)


gradualFader.setopacity=function(obj, value){ //Sets the opacity of targetobject based on the passed in value setting (0 to 1 and in between)
    var targetobject=obj
    if (targetobject && targetobject.filters && targetobject.filters[0]){ //IE syntax
	if (typeof targetobject.filters[0].opacity=="number") //IE6
	    targetobject.filters[0].opacity=value*100
	else //IE 5.5
	    targetobject.style.filter="alpha(opacity="+value*100+")"
    }
    else if (targetobject && typeof targetobject.style.MozOpacity!="undefined") //Old Mozilla syntax
	targetobject.style.MozOpacity=value
    else if (targetobject && typeof targetobject.style.opacity!="undefined") //Standard opacity syntax
	targetobject.style.opacity=value
	
    targetobject.currentopacity=value
}

gradualFader.fadeupdown=function(obj, direction){
    var targetobject=obj
    var fadeamount=(direction=="fadeup")? this.increment : -this.increment
    if (targetobject && (direction=="fadeup" && targetobject.currentopacity<1 || direction=="fadedown" && targetobject.currentopacity>this.baseopacity)){
	this.setopacity(obj, targetobject.currentopacity+fadeamount)
	window["opacityfader"+obj._fadeorder]=setTimeout(function(){gradualFader.fadeupdown(obj, direction)}, 50)
    }
}

gradualFader.clearTimer=function(obj){
    if (typeof window["opacityfader"+obj._fadeorder]!="undefined")
        clearTimeout(window["opacityfader"+obj._fadeorder])
}

gradualFader.isContained=function(m, e){
    var e=window.event || e
    var c=e.relatedTarget || ((e.type=="mouseover")? e.fromElement : e.toElement)
    while (c && c!=m)try {c=c.parentNode} catch(e){c=m}
	
    if (c==m)
	return true
    else
	return false
}

gradualFader.fadeinterface=function(obj, e, direction){
    if (!this.isContained(obj, e)){
        gradualFader.clearTimer(obj)
	gradualFader.fadeupdown(obj, direction)
    }
}

gradualFader.collectElementbyClass=function(classname){ //Returns an array containing DIVs with specified classname
    var classnameRE=new RegExp("(^|\\s+)"+classname+"($|\\s+)", "i") //regular expression to screen for classname within element
    var pieces=[]

    var alltags=document.all? document.all : document.getElementsByTagName("*")
    for (var i=0; i<alltags.length; i++){
        if (typeof alltags[i].className=="string" && alltags[i].className.search(classnameRE)!=-1)
	    pieces[pieces.length]=alltags[i];
    }
    return pieces
}

gradualFader.init=function(){

    var targetobjects=this.collectElementbyClass("gradualfader")
    for (var i=0; i<targetobjects.length; i++){
	targetobjects[i]._fadeorder=i
	this.setopacity(targetobjects[i], this.baseopacity)
	targetobjects[i].onmouseover=function(e){gradualFader.fadeinterface(this, e, "fadeup")}
	targetobjects[i].onmouseout=function(e){gradualFader.fadeinterface(this, e, "fadedown")}
    }
}	